

from .field import Field
# -------------
# STRING
# -------------
class FieldString(Field):

    def __init__(self, fieldname, fieldschema, alljson):
        super().__init__(fieldname, fieldschema, alljson)

        # if no json, unpack default_value
        if not alljson:
            if self.default_value:
                self.value = self.default_value


    def __init__(self, fieldname, fieldschema, alljson):
        super().__init__(fieldname, fieldschema, alljson)

        # if no json, use default_value string ; no multivalue
        if not alljson:
            if self.default_value:
                self.value = [self.default_value]


    def merge_edit_data(self, data):
        self.value = []
        for i in data:
            if len(i) > 0:
                self.value.append(i)

    def merge_new_data(self, data):
        self.value = []
        for i in data:
            if len(i) > 0:
                self.value.append(i)

    def merge_import_data(self, data):
        # no split composite !
        self.value = []
        if type(data) is str:
            self.value = [data]
        elif type(data) is list:
            for i in data:
                self.value.append(i)

    def is_valid(self):
        r = super().is_valid()
        # TODO
        return r

