# (c) cavaliba.com - sirene - register.py


APP_NAME = "sirene"

# permissions
# roles        : admin, operator, sms  ; built-in role_default in cavaliba.py
# app          : schema + permissions (Admin + CRUD + Imp + Exp)
# site
# sitegroup
# customer

BUILTIN_DATA = '''

# --------------------------------------------
# permissions
# --------------------------------------------

- classname: _permission
  keyname: p_sirene_access
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE app access"
  displayname: ""

- classname: _permission
  keyname: p_sirene_access_restricted
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE  access to private restricted messages"
  displayname: ""

- classname: _permission
  keyname: p_sirene_detail
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE access details"
  displayname: ""

- classname: _permission
  keyname: p_sirene_history
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE access history"
  displayname: ""

- classname: _permission
  keyname: p_sirene_new
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE create a new notification"
  displayname: ""

- classname: _permission
  keyname: p_sirene_update
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE update a notification"
  displayname: ""

- classname: _permission
  keyname: p_sirene_archive
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE archive a notification"
  displayname: ""

- classname: _permission
  keyname: p_sirene_public_push
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE push a public page"
  displayname: ""

- classname: _permission
  keyname: p_sirene_flushall
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE archive all active notifications"
  displayname: ""

- classname: _permission
  keyname: p_sirene_cat_read
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE RO/view category"
  displayname: ""

- classname: _permission
  keyname: p_sirene_cat_cud
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE RW/edit category"
  displayname: ""

- classname: _permission
  keyname: p_sirene_public_read
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE RO/view public page models"
  displayname: ""

- classname: _permission
  keyname: p_sirene_public_cud
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE RW/edit public page models"
  displayname: ""


- classname: _permission
  keyname: p_sirene_template_read
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE RO templates"
  displayname: ""

- classname: _permission
  keyname: p_sirene_template_cud
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE RW templates"
  displayname: ""


- classname: _permission
  keyname: p_sirene_sms_send
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE SMS Send"
  displayname: ""

- classname: _permission
  keyname: p_sirene_sms_journal
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE SMS Journal"
  displayname: ""

- classname: _permission
  keyname: p_sirene_sms_stat
  is_builtin: True
  appname: sirene
  description: "Built-in SIRENE SMS Stat"
  displayname: ""


# --------------------------------------------
# roles
# --------------------------------------------


- classname: _role
  keyname: role_sirene_admin
  is_builtin: True
  displayname: Built-in Sirene admin Role
  permissions: 
    - p_sirene_access
    - p_sirene_access_restricted
    - p_sirene_detail
    - p_sirene_history
    - p_sirene_new
    - p_sirene_update
    - p_sirene_archive
    - p_sirene_public_push
    - p_sirene_flushall
    - p_sirene_cat_read
    - p_sirene_cat_cud
    - p_sirene_public_read
    - p_sirene_public_cud
    - p_sirene_template_cud
    - p_sirene_template_read
    - p_sirene_sms_send
    - p_sirene_sms_journal
    - p_sirene_sms_stat
    - p_home_access
    - p_iam_access
    - p_user_read
    - p_group_read
    - p_data_access


- classname: _role
  keyname: role_sirene_operator
  is_builtin: True
  displayname: Built-in Sirene Operator Role
  permissions: 
    - p_sirene_access
    - p_sirene_access_restricted
    - p_sirene_detail
    - p_sirene_history
    - p_sirene_new
    - p_sirene_update
    - p_sirene_archive
    - p_sirene_public_push
    - p_sirene_flushall
    - p_sirene_cat_read
    - p_sirene_public_read
    - p_sirene_template_read
    - p_sirene_sms_send
    - p_sirene_sms_journal
    - p_sirene_sms_stat
    - p_home_access
    - p_iam_access
    - p_user_read
    - p_group_read
    - p_data_access
    - p_data_read
    - p_data_app_read
    - p_data_site_read
    - p_data_sitegroup_read
    - p_data_customer_read


- classname: _role
  keyname: role_sirene_sms
  is_builtin: True
  displayname: Built-in Sirene direct SMS 
  permissions: 
    - p_sirene_access
    - p_sirene_sms_send
    

# --------------------------------------------
# app
# --------------------------------------------

- classname: _permission
  keyname: p_data_app_admin
  is_builtin: True
  description: "Built-in data_app admin permission"
  displayname: "p_data_app_admin"

- classname: _permission
  keyname: p_data_app_create
  is_builtin: True
  description: "Built-in data_app create permission"
  displayname: p_data_app_create

- classname: _permission
  keyname: p_data_app_read
  is_builtin: True
  description: "Built-in data_app read permission"
  displayname: p_data_app_read

- classname: _permission
  keyname: p_data_app_update
  is_builtin: True
  description: "Built-in data_app update permission"
  displayname: p_data_app_update
      
- classname: _permission
  keyname: p_data_app_delete
  is_builtin: True
  description: "Built-in data_app delete permission"
  displayname: p_data_app_delete

- classname: _permission
  keyname: p_data_app_import
  is_builtin: True
  description: "Built-in data_app import permission"
  displayname: p_data_app_import

- classname: _permission
  keyname: p_data_app_export
  is_builtin: True
  description: "Built-in data_app export permission"
  displayname: p_data_app_export

- classname: _schema
  keyname: app
  displayname: Applications
  is_enabled: yes
  icon: fa-window-maximize
  order: 50
  page: Sirene
  handle_method: md5
  p_admin: p_data_app_admin
  p_create: p_data_app_create
  p_read: p_data_app_read
  p_update: p_data_app_update
  p_delete: p_data_app_delete
  p_import: p_data_app_import
  p_export: p_data_app_export
  description:
        displayname: Description
        order: 100
        dataformat: string
  sirene_group:
        displayname: Sirene User Groups to notify
        order: 120
        dataformat: group
        cardinal_max: 0

# --------------------------------------------
# site
# --------------------------------------------


- classname: _permission
  keyname: p_data_site_admin
  is_builtin: True
  description: "Built-in data_site admin permission"
  displayname: "p_data_site_admin"

- classname: _permission
  keyname: p_data_site_create
  is_builtin: True
  description: "Built-in data_site create permission"
  displayname: p_data_site_create

- classname: _permission
  keyname: p_data_site_read
  is_builtin: True
  description: "Built-in data_site read permission"
  displayname: p_data_site_read

- classname: _permission
  keyname: p_data_site_update
  is_builtin: True
  description: "Built-in data_site update permission"
  displayname: p_data_site_update
      
- classname: _permission
  keyname: p_data_site_delete
  is_builtin: True
  description: "Built-in data_site delete permission"
  displayname: p_data_site_delete

- classname: _permission
  keyname: p_data_site_import
  is_builtin: True
  description: "Built-in data_site import permission"
  displayname: p_data_site_import

- classname: _permission
  keyname: p_data_site_export
  is_builtin: True
  description: "Built-in data_site export permission"
  displayname: p_data_site_export
      

- classname: _schema
  keyname: site
  #_action: create
  displayname: Sites
  is_enabled: yes
  order: 60
  page: Sirene
  icon: fa-hospital-o
  handle_method: md5
  p_admin: p_data_site_admin
  p_create: p_data_site_create
  p_read: p_data_site_read
  p_update: p_data_site_update
  p_delete: p_data_site_delete
  p_import: p_data_site_import
  p_export: p_data_site_export
  description:
        _action: create
        displayname: Sites, HQ and Facilities
        order: 100
        dataformat: string
  sirene_group:
        displayname: Sirene User Groups to notify
        page: Sirene
        order: 500
        dataformat: group
        cardinal_max: 0
  sirene_app:      
        displayname: Sirene App subscriptions
        page: Sirene
        order: 510           
        dataformat: schema
        dataformat_ext: app
        cardinal_max: 0

        
# --------------------------------------------
# sitegroup
# --------------------------------------------


- classname: _permission
  keyname: p_data_sitegroup_admin
  is_builtin: True
  description: "Built-in data_sitegroup admin permission"
  displayname: "p_data_sitegroup_admin"

- classname: _permission
  keyname: p_data_sitegroup_create
  is_builtin: True
  description: "Built-in data_sitegroup create permission"
  displayname: p_data_sitegroup_create

- classname: _permission
  keyname: p_data_sitegroup_read
  is_builtin: True
  description: "Built-in data_sitegroup read permission"
  displayname: p_data_sitegroup_read

- classname: _permission
  keyname: p_data_sitegroup_update
  is_builtin: True
  description: "Built-in data_sitegroup update permission"
  displayname: p_data_sitegroup_update
      
- classname: _permission
  keyname: p_data_sitegroup_delete
  is_builtin: True
  description: "Built-in data_sitegroup delete permission"
  displayname: p_data_sitegroup_delete

- classname: _permission
  keyname: p_data_sitegroup_import
  is_builtin: True
  description: "Built-in data_sitegroup import permission"
  displayname: p_data_sitegroup_import

- classname: _permission
  keyname: p_data_sitegroup_export
  is_builtin: True
  description: "Built-in data_sitegroup export permission"
  displayname: p_data_sitegroup_export
      


- classname: _schema
  keyname: sitegroup
  displayname: Groups of Sites
  is_enabled: yes
  icon: fa-university
  order: 70
  page: Sirene
  handle_method: md5
  p_admin: p_data_sitegroup_admin
  p_create: p_data_sitegroup_create
  p_read: p_data_sitegroup_read
  p_update: p_data_sitegroup_update
  p_delete: p_data_sitegroup_delete
  p_import: p_data_sitegroup_import
  p_export: p_data_sitegroup_export
  description:
        #_action: create
        displayname: Description
        order: 100
        dataformat: string
  members:
        displayname: Sirene - Sites (members)
        page: Sirene
        order: 500           
        dataformat: schema
        dataformat_ext: site
        cardinal_max: 0
  subgroups:
        displayname: Sirene - Subgroups of sites
        page: Sirene
        order: 510
        dataformat: schema
        dataformat_ext: sitegroup
        cardinal_max: 0
  sirene_group:
        displayname: Sirene - Direct User Groups 
        page: Sirene
        order: 520
        dataformat: group
        cardinal_max: 0

        
# --------------------------------------------
# customer
# --------------------------------------------


- classname: _permission
  keyname: p_data_customer_admin
  is_builtin: True
  description: "Built-in data_customer admin permission"
  displayname: "p_data_customer_admin"

- classname: _permission
  keyname: p_data_customer_create
  is_builtin: True
  description: "Built-in data_customer create permission"
  displayname: p_data_customer_create

- classname: _permission
  keyname: p_data_customer_read
  is_builtin: True
  description: "Built-in data_customer read permission"
  displayname: p_data_customer_read

- classname: _permission
  keyname: p_data_customer_update
  is_builtin: True
  description: "Built-in data_customer update permission"
  displayname: p_data_customer_update
      
- classname: _permission
  keyname: p_data_customer_delete
  is_builtin: True
  description: "Built-in data_customer delete permission"
  displayname: p_data_customer_delete

- classname: _permission
  keyname: p_data_customer_import
  is_builtin: True
  description: "Built-in data_customer import permission"
  displayname: p_data_customer_import

- classname: _permission
  keyname: p_data_customer_export
  is_builtin: True
  description: "Built-in data_customer export permission"
  displayname: p_data_customer_export
      

- classname: _schema
  keyname: customer
  displayname: Customers
  is_enabled: yes
  icon: fa-credit-card
  order: 290
  page: Data
  handle_method: md5
  p_admin: p_data_customer_admin
  p_create: p_data_customer_create
  p_read: p_data_customer_read
  p_update: p_data_customer_update
  p_delete: p_data_customer_delete
  p_import: p_data_customer_import
  p_export: p_data_customer_export
  
  description:
        #_action: create
        displayname: Description
        order: 100
        dataformat: string
  sirene_group:
        displayname: Sirene User Groups to notify
        order: 150
        dataformat: group
        cardinal_max: 0
        
'''

